--declaring global variables
player = {}

local utf8 = require("utf8")

function player.load()
	
	love.graphics.setBackgroundColor(255,255,255)
	
	player.selecConfirmed = false
	
	player.tommyCatt = {}
	player.tommyCatt.name = "Tommy Catt"
	player.tommyCatt.image = love.graphics.newImage("Tommy Catt.png")
	player.tommyCatt.unlocked = true
	player.tommyCatt.maxFrameDelay = 10
	player.tommyCatt.startingItems = {}
	
	player.tommyCatt.startingItems.one = {}
	player.tommyCatt.startingItems.one.item = tools.woodenAxe
	player.tommyCatt.startingItems.one.count = 1
	
	player.tommyCatt.startingItems.two = {}
	player.tommyCatt.startingItems.two.item = tools.woodenSword
	player.tommyCatt.startingItems.two.count = 1
	
	player.tommyCatt.startingItems.three = {}
	player.tommyCatt.startingItems.three.item = items.cookie
	player.tommyCatt.startingItems.three.count = 5
	
	player.mysterii = {}
	player.mysterii.name = "Mysterii"
	player.mysterii.image = love.graphics.newImage("Mysterii.png")
	player.mysterii.unlocked = true
	player.mysterii.maxFrameDelay = 10
	player.mysterii.startingItems = {}
	
	player.mysterii.startingItems.one = {}
	player.mysterii.startingItems.one.item = tools.woodenAxe
	player.mysterii.startingItems.one.count = 1
	
	player.mysterii.startingItems.two = {}
	player.mysterii.startingItems.two.item = items.teleportStone
	player.mysterii.startingItems.two.count = 5
	
	player.mysterii.startingItems.three = {}
	player.mysterii.startingItems.three.item = items.mysteriousCrystal
	player.mysterii.startingItems.three.count = 1
	
	player.fireMage = {}
	player.fireMage.name = "Flarore"
	player.fireMage.image = love.graphics.newImage("Flarore.png")
	player.fireMage.unlocked = true
	player.fireMage.maxFrameDelay = 20
	player.fireMage.startingItems = {}
	
	player.fireMage.startingItems.one = {}
	player.fireMage.startingItems.one.item = tools.fireEssence
	player.fireMage.startingItems.one.count = 5
	
	player.fireMage.startingItems.two = {}
	player.fireMage.startingItems.two.item = tools.stoneAxe
	player.fireMage.startingItems.two.count = 1
	
	player.fireMage.startingItems.three = {}
	player.fireMage.startingItems.three.item = items.copperIngot
	player.fireMage.startingItems.three.count = 3
	
	player.selected = {}
	player.selected.character = player.tommyCatt
	player.selected.stat1 = 0
	player.selected.stat2 = 0
	player.name = player.mysterii.name
	player.inventory = {}
	
	player.current = {}
	player.tommyCatt.width = player.tommyCatt.image:getWidth()
	player.tommyCatt.height = player.tommyCatt.image:getHeight()
	player.current.width = player.tommyCatt.width
	player.current.height = player.tommyCatt.height
	player.current.frameDelay = 10
	player.current.maxFrameDelay = 0
	
	player.default = {}
	player.default.frame = {}
	player.default.frame.one = love.graphics.newQuad(0,0,32,32,player.current.width,player.current.height)
	player.default.frame.two = love.graphics.newQuad(0,32,32,32,player.current.width,player.current.height)
	player.default.frame.three = love.graphics.newQuad(0,64,32,32,player.current.width,player.current.height)
	player.default.frame.four = love.graphics.newQuad(0,96,32,32,player.current.width,player.current.height)
	
	player.current.frame = player.default.frame.one
	
	player.x = 20
	player.y = 30
	
end

function player.draw()
	
	if player.selecConfirmed == false then
		
		player.selecDraw()
		
	end
	
	if gamestate == "playing" then
		
		love.graphics.setColor(255,255,255)
		love.graphics.draw(player.selected.character.image,player.current.frame,player.x,player.y)
		
	end
	
	if gamestate == "nameScreen" then
		
		love.graphics.setColor(255,255,255)
		love.graphics.draw(background.one)
		
		love.graphics.setColor(200,200,200)
		love.graphics.rectangle("fill",love.graphics.getWidth() - 200, love.graphics.getHeight() / 2 - 10, 150, 20)
		love.graphics.setColor(155,155,155)
		love.graphics.rectangle("line",love.graphics.getWidth() - 200, love.graphics.getHeight() / 2 - 10, 150, 20)
		
		love.graphics.setColor(0,0,0)
		love.graphics.print("What Is Your Name?", love.graphics.getWidth() - 200, love.graphics.getHeight() / 2 - 35)
		
		love.graphics.setColor(0,0,0)
		love.graphics.print(player.name, love.graphics.getWidth() - 200, love.graphics.getHeight() / 2 - 10)
	
		love.graphics.setColor(255,255,255)
	
		love.graphics.draw(button.confirm, love.graphics.getWidth() - 34, love.graphics.getHeight() - 34)
		
	end
	
end

function player.update()
	
	if player.selecConfirmed == false then
		
		player.selecUpdate()
		
	end
	
	if gamestate == "nameScreen" then
		
		if mouse.x > love.graphics.getWidth() - 34
		and mouse.x < love.graphics.getWidth() - 2
		and mouse.y > love.graphics.getHeight() - 34
		and mouse.y < love.graphics.getHeight() - 2
		and love.mouse.isDown(1)
		and mousepressed == false then
			
			gamestate = "menu"
			mousepressed = true
			
		end
		
	end
	
	if player.current.frameDelay > 0 then
		
		player.current.frameDelay = player.current.frameDelay - 1
		
	elseif player.current.frameDelay == 0 then
		
		if player.current.frame == player.default.frame.one then
			
			player.current.frame = player.default.frame.two
			
		elseif player.current.frame == player.default.frame.two then
			
			player.current.frame = player.default.frame.three
			
		elseif player.current.frame == player.default.frame.three then
			
			player.current.frame = player.default.frame.four
			
		elseif player.current.frame == player.default.frame.four then
			
			player.current.frame = player.default.frame.one
			
		end
		
		player.current.frameDelay = player.selected.character.maxFrameDelay
		
	end
	
end

--Time for player selection!

-- !WARNING!
--Prepare for messy code!

function player.selecDraw()
	
	love.graphics.setColor(255,255,255)
	love.graphics.draw(background.one)
	
	if player.tommyCatt.unlocked == false then
		
		love.graphics.setColor(100,100,100)
		love.graphics.draw(player.tommyCatt.image,player.default.frame.one,10, 10)
		
	elseif player.tommyCatt.unlocked then
		
		love.graphics.setColor(255,255,255)
		
		if player.selected.character == player.tommyCatt then
			
			love.graphics.draw(player.tommyCatt.image,player.current.frame, 10,10)
			love.graphics.rectangle("line",8,8,36,36)
			
		else
			
			love.graphics.draw(player.tommyCatt.image,player.default.frame.one, 10, 10)
			
		end
		
	end
	
	if mouse.x > 10
	and mouse.x < 42
	and mouse.y > 10
	and mouse.y < 42 then
		
		love.graphics.rectangle("line",8,8,36,36)
		
	end
	
	if player.fireMage.unlocked == false then
		
		love.graphics.setColor(100,100,100)
		player.selected.character = player.fireMage
		love.graphics.draw(player.fireMage.image,player.default.frame.one, 52, 10)
		
	elseif player.fireMage.unlocked then
		
		love.graphics.setColor(255,255,255)
		
		if player.selected.character == player.fireMage then
			
			love.graphics.draw(player.fireMage.image,player.current.frame, 52,10)
			love.graphics.rectangle("line",50,8,36,36)
			
		else
			
			love.graphics.draw(player.fireMage.image,player.default.frame.one, 52, 10)
			
		end
		
	end
	
	if mouse.x > 52
	and mouse.x < 84
	and mouse.y > 10
	and mouse.y < 42 then
		
		love.graphics.rectangle("line",50,8,36,36)
		
	end
	
	if player.mysterii.unlocked == false then
		
		love.graphics.setColor(100,100,100)
		love.graphics.draw(player.mysterii.image,player.default.frame.one, 94, 10)
		
	elseif player.mysterii.unlocked then
		
		love.graphics.setColor(255,255,255)
		
		if player.selected.character == player.mysterii then
			
			love.graphics.draw(player.mysterii.image,player.current.frame, 94,10)
			love.graphics.rectangle("line",92,8,36,36)
			
		else
			
			love.graphics.draw(player.mysterii.image,player.default.frame.one, 94, 10)
			
		end
		
	end
	
	if mouse.x > 94
	and mouse.x < 126
	and mouse.y > 10
	and mouse.y < 42 then
		
		love.graphics.rectangle("line",92,8,36,36)
		
	end
	
	
	
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill", 8, love.graphics.getHeight() - 64, 36, 36)
	
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("line", 8, love.graphics.getHeight() - 64, 36, 36)
	
	love.graphics.draw(player.selected.character.image, player.current.frame, 10, love.graphics.getHeight() - 62)
	love.graphics.setColor(0,0,0)
	love.graphics.print(player.selected.character.name,10, love.graphics.getHeight() - 20)
	
	love.graphics.setColor(255,255,255)
	
	love.graphics.draw(button.confirm, love.graphics.getWidth() - 34, love.graphics.getHeight() - 34)
	
end

function player.selecUpdate()
	
	gamestate = "menu"
	
	if player.tommyCatt.unlocked == false
	and player.mysterii.unlocked == false then
		
		player.tommyCatt.unlocked = true
		
	end
	
	if mouse.x > love.graphics.getWidth() - 34
	and mouse.x < love.graphics.getWidth() - 2
	and mouse.y > love.graphics.getHeight() - 34
	and mouse.y < love.graphics.getHeight() - 2
	and love.mouse.isDown(1)
	and mousepressed == false then
		
		player.selecConfirmed = true
		gamestate = "nameScreen"
		mousepressed = true
		
	end
	
	if mouse.x > 10
	and mouse.x < 42
	and mouse.y > 10
	and mouse.y < 42
	and love.mouse.isDown(1)
	and mousepressed == false then
		
		player.selected.character = player.tommyCatt
		
	elseif mouse.x > 52
	and mouse.x < 84
	and mouse.y > 10
	and mouse.y < 42
	and love.mouse.isDown(1)
	and mousepressed == false then
		
		player.selected.character = player.fireMage
		
	elseif mouse.x > 94
	and mouse.x < 126
	and mouse.y > 10
	and mouse.y < 42
	and love.mouse.isDown(1)
	and mousepressed == false then
		
		player.selected.character = player.mysterii
		
	end
	
end

function player.keypressed(key)
    
	if gamestate == "nameScreen" then
		
		if key == "backspace" then
			
			local byteoffset = utf8.offset(player.name, -1)
	
			if byteoffset then
				
				player.name = string.sub(player.name, 1, byteoffset - 1)
				
			end
			
		end
		
	end
	
end

function player.textinput(t)
	
	if selecConfirmed == false then
		
		t = player.current.character.name
		
	end
	
	if gamestate == "nameScreen" then
		
		player.name = player.name..t
		
	end
	
end